import java.io.*;
import java.nio.file.*;
import java.util.Scanner;
import java.util.ArrayList;

public class File{
    public static final String IN = java.io.File.separator;
    java.io.File file = null;
    
    public File(String filename){
        file = new java.io.File(filename);
        if(file == null || !file.exists()){
            try{Files.createFile(Paths.get(filename));}
            catch(IOException e_){}
        }
    }
    
    public String[] read(){
        ArrayList<String> data = new ArrayList<String>();
        try{
            Scanner in = new Scanner(file);
            while(in.hasNextLine()) data.add(in.nextLine());
            in.close(); 
          }catch(FileNotFoundException f){
            System.err.println("FileNotFound: " + file.getName());
          }catch(NullPointerException e){
            System.err.println("failed to read from file: " + file.getName());
        }return (data.size() != 0)? java.util.Arrays.copyOf(data.toArray(), data.size(), String[].class) : new String[]{""};
    }
    public void write(String[] data){
       try{
          PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(toString())));
          for(String line : data) out.println(line);
          out.close();
       }catch(IOException e){
          System.err.println("failed to write to file: " + file.getName());
       }
    }
}