import greenfoot.*;
public class Song{
    private static final String[] sounds = loadSound();
    private String song = "";
    public Song(String filename){
        File file = new File("music"+File.IN+filename+".txt");
        String[] lines = file.read();
        for(int i = 1; i < lines.length; i++){
              for(int m = lines[i].indexOf("M"); 1 < m; m = lines[i].indexOf("M")){
                for(int j = m; lines[i].length() - m < 4; j++) lines[i] += " ";
                lines[i] = lines[i].substring(0,m-2) 
                + toNotes(major(lines[i].charAt(m-2)+""+lines[i].charAt(m-1))) 
                + lines[i].substring(m+4);
            } for(int m = lines[i].indexOf("m"); 1 < m; m = lines[i].indexOf("m")){
                for(int j = m; lines[i].length() - m < 4; j++) lines[i] += " ";
                lines[i] = lines[i].substring(0,m-2) 
                + toNotes(minor(lines[i].charAt(m-2)+""+lines[i].charAt(m-1))) 
                + lines[i].substring(m+4);
            } for(int j = lines[i].length(); lines[i].length() < 64; lines[i] += " ");
            song += lines[i];
        }
    }
    public Song(int[] keys){
        for(int i = 0; i < keys.length; i++) song += toKey(keys[0]);
        this.song = song;
    }
    
    
    @Override public String toString(){
        String _song = "";
        for(int i = 0; i < song.length(); i++){
            if(i != 0 && i%16 == 0) _song += "\n";
            _song += song.charAt(i);
            if(i%2 == 0) _song += " ";
        }
        return _song;
    }
    public int length(){ return song.length()/2 - 1; }
    
    
    public static String[] loadSound(){
        String[] sounds = new String[88];
        for(int i = 1; i <= 88; i++)
            sounds[i-1] = (65 <= i && i <= 84)? (i + ".mp3") : (i + ".wav");
        return sounds;
    }
    public static String toKey(int key){
        String sKey = "";
        if(0 == key) sKey = "_ ";
        else if(1 <= key && key <= 88){
            switch((key-1) % 12){
                case 0:  sKey = "a"; break;
                case 1:  sKey = "A"; break;
                case 2:  sKey = "b"; break;
                case 3:  sKey = "c"; break;
                case 4:  sKey = "C"; break;
                case 5:  sKey = "d"; break;
                case 6:  sKey = "D"; break;
                case 7:  sKey = "e"; break;
                case 8:  sKey = "f"; break;
                case 9:  sKey = "F"; break;
                case 10: sKey = "g"; break;
                case 11: sKey = "G"; break;
            } sKey += ((key-1)/12 + "");
        } return sKey;
    }
    public static int toKey(String key){
        int total = 0;
        switch(key.charAt(0)){
            case 'a': total = 1; break;
            case 'A': total = 2; break;
            case 'b': total = 3; break;
            case 'c': total = 4; break;
            case 'C': total = 5; break;
            case 'd': total = 6; break;
            case 'D': total = 7; break;
            case 'e': total = 8; break;
            case 'f': total = 9; break;
            case 'F': total = 10; break;
            case 'g': total = 11; break;
            case 'G': total = 12; break;
        } int octave = key.charAt(1) - '0';
        total += 12*octave;
        return total;
    }
    
    
    public void play(int cue){
        cue *= 2;
        if(song.charAt(cue) == '_') Greenfoot.playSound("tap.wav");
        else if(song.charAt(cue) != ' '){
            int total = toKey(song.charAt(cue) + "" + song.charAt(cue+1));
            String type = (65 <= total && total <= 84)? ".mp3" : ".wav";
            if(0 < total && total <= 88) Greenfoot.playSound(total + type);
        }
    }
    
    
    
    //Chords:
    public static boolean isWhiteKey(int key){ key = key % 12; return(key == 0 || Math.abs(key-5) == 1 || Math.abs(key-5) == 4); }
    public static int nextWhiteKey(int key){ for(int i = key; i <= 88; i++) if(isWhiteKey(i)) return i; return key; }
    public static int nextBlackKey(int key){ for(int i = key; i <= 88; i++) if(!isWhiteKey(i)) return i; return key; }
    public static String toNotes(int[] chord){
        String total = ""; 
        for(int i = 0; i < chord.length; i++) total += toKey(chord[i]);
        return total;
    }
    
    public static int[] minor(String note){
        int[] chord = new int[3];
        chord[0] = toKey(note);
        chord[1] = chord[0] + 3;
        if(88 < chord[1]){ chord[1] = chord[0]; chord[2] = chord[0]; }
        else{ chord[2] = chord[1] + 4;
            if(88 < chord[2]){ chord[2] = chord[1]; }
        } return chord;
    }
    public int[] major(String note){
        int[] chord = new int[3];
        chord[0] = toKey(note);
        chord[1] = chord[0] + 4;
        if(88 < chord[1]){ chord[1] = chord[0]; chord[2] = chord[0]; }
        else{ chord[2] = chord[1] + 3;
            if(88 < chord[2]){ chord[2] = chord[1]; }
        } return chord;
    }
}
