import greenfoot.*;
public class Zone extends World{
    public static final int[] size = {700,500};
    public static final int UNITSIZE = 50;
    public static final ratio GRAVITY = new ratio(1,2);
    
    public static Player player = null;
    public static Song song = null;
    
    public Zone(String filename){    
        super(size[0],size[1],1,false);
        setPaintOrder(Image.class,Player.class,Scrollable.class,Sky.class);
        switch(Greenfoot.getRandomNumber(4)){
            case 0: player = new Player("Red"); break;
            case 1: player = new Player("Yellow"); break;
            case 2: player = new Player("Green"); break;
            case 3: player = new Player("Blue"); break;
        }
        load(filename,"");
        song = new Song(filename);
        musicframe = 0;
    }
    
    private int musicframe = 0;
    public void act(){
        if(musicframe < song.length()) song.play(musicframe);
        musicframe = (musicframe+1) % song.length();
    }
    
    public void move(int x,int y){
        for(Scrollable s : getObjects(Scrollable.class))
            s.setLocation(s.getX()-x,s.getY()-y);
    }
    
    public String[] autosave = {"",""};
    public void load(String filename,String door){
        autosave[0] = filename;
        autosave[1] = door;
        for(Actor a : getObjects(Actor.class)) removeObject(a);
        File file = new File("maps" + File.IN + filename + ".txt");
        String[] tiles = file.read();
        int[] spawnpoint = {0,0};
        for(int y = 0; y < tiles.length; y++)
            for(int x = 0; x < tiles[y].length(); x++){
                Tile tile = null;
                char tiletype = tiles[y].charAt(x);
                switch(tiletype){
                    case '0': if(door == "") spawnpoint = new int[]{UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2}; break;
                    case 'G': tile = new Tile("ground.png"); break;
                    case 'T': addObject(new Thing("tree.png",3*UNITSIZE/2,3*UNITSIZE),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y-UNITSIZE/2+15); break;
                    case 'S': addObject(new Thing("shrub.png",5*UNITSIZE/4,5*UNITSIZE/4),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2); break;
                    case 'B': addObject(new Thing("bush.png",3*UNITSIZE/2,UNITSIZE),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2+5); break;
                    case 'R': addObject(new Thing("rock.png",UNITSIZE,UNITSIZE),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2); break;
                    case 'W': addObject(new Spike(UNITSIZE,UNITSIZE),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2); break;
                    case '=': try{ String target = tiles[y].substring(x+1);
                        boolean isDoor = true; 
                        for(int i = 0; i < door.length(); i++) if(door.charAt(i)!=target.charAt(i)) isDoor = false;
                        if(door != "" && isDoor)
                            spawnpoint = new int[]{UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2};
                            addObject(new Door(player+"",filename,target),UNITSIZE*x+UNITSIZE/2,UNITSIZE*y+UNITSIZE/2);
                    }catch(Exception e){} break;
                } if(tile != null){
                    tile.getImage().scale(UNITSIZE,UNITSIZE);
                    addObject(tile, UNITSIZE*x+UNITSIZE/2, UNITSIZE*y+UNITSIZE/2);
                }
            } move(spawnpoint[0]-size[0]/2,spawnpoint[1]-size[1]/2);
         addObject(player,size[0]/2,size[1]/2);
         for(int i = 0; i < player.HP.length; i++) 
            if(player.HP[i] != null) addObject(player.HP[i],30 *(i+1),30);
         addObject(new Sky(player+"",size[0],size[1]),size[0]/2,size[1]/2);
    }
}
